
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module C5G_HDMI(

	//////////// CLOCK //////////
	CLOCK_125_p,
	CLOCK_50_B5B,
	CLOCK_50_B6A,
	CLOCK_50_B7A,
	CLOCK_50_B8A,

	//////////// LED //////////
	LEDG,
	LEDR,

	//////////// KEY //////////
	CPU_RESET_n,
	KEY,

	//////////// SW //////////
	SW,

	//////////// SEG7 //////////
	HEX0,
	HEX1,

	//////////// HDMI-TX //////////
	HDMI_TX_CLK,
	HDMI_TX_D,
	HDMI_TX_DE,
	HDMI_TX_HS,
	HDMI_TX_INT,
	HDMI_TX_VS,

	//////////// ADC SPI //////////
	ADC_CONVST,
	ADC_SCK,
	ADC_SDI,
	ADC_SDO,

	//////////// Audio //////////
	AUD_ADCDAT,
	AUD_ADCLRCK,
	AUD_BCLK,
	AUD_DACDAT,
	AUD_DACLRCK,
	AUD_XCK,

	//////////// I2C for Audio/HDMI-TX/Si5338/HSMC //////////
	I2C_SCL,
	I2C_SDA,

	//////////// SDCARD //////////
	SD_CLK,
	SD_CMD,
	SD_DAT,

	//////////// Uart to USB //////////
	UART_RX,
	UART_TX,

	//////////// SRAM //////////
	SRAM_A,
	SRAM_CE_n,
	SRAM_D,
	SRAM_LB_n,
	SRAM_OE_n,
	SRAM_UB_n,
	SRAM_WE_n,
	
	//////////// LPDDR2 //////////
	DDR2LP_CA,
	DDR2LP_CK_n,
	DDR2LP_CK_p,
	DDR2LP_CKE,
	DDR2LP_CS_n,
	DDR2LP_DM,
	DDR2LP_DQ,
	DDR2LP_DQS_n,
	DDR2LP_DQS_p,
	DDR2LP_OCT_RZQ,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	GPIO  	

);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_125_p;
input 		          		CLOCK_50_B5B;
input 		          		CLOCK_50_B6A;
input 		          		CLOCK_50_B7A;
input 		          		CLOCK_50_B8A;

//////////// LED //////////
output		     [7:0]		LEDG;
output		     [9:0]		LEDR;

//////////// KEY //////////
input 		          		CPU_RESET_n;
input 		     [3:0]		KEY;

//////////// SW //////////
input 		     [9:0]		SW;

//////////// SEG7 //////////
output		     [6:0]		HEX0;
output		     [6:0]		HEX1;

//////////// HDMI-TX //////////
output		          		HDMI_TX_CLK;
output		    [23:0]		HDMI_TX_D;
output		          		HDMI_TX_DE;
output		          		HDMI_TX_HS;
input 		          		HDMI_TX_INT;
output		          		HDMI_TX_VS;

//////////// ADC SPI //////////
output		          		ADC_CONVST;
output		          		ADC_SCK;
output		          		ADC_SDI;
input 		          		ADC_SDO;

//////////// Audio //////////
input 		          		AUD_ADCDAT;
inout 		          		AUD_ADCLRCK;
inout 		          		AUD_BCLK;
output		          		AUD_DACDAT;
inout 		          		AUD_DACLRCK;
output		          		AUD_XCK;

//////////// I2C for Audio/HDMI-TX/Si5338/HSMC //////////
output		          		I2C_SCL;
inout 		          		I2C_SDA;

//////////// SDCARD //////////
output		          		SD_CLK;
inout 		          		SD_CMD;
inout 		     [3:0]		SD_DAT;

//////////// Uart to USB //////////
input 		          		UART_RX;
output		          		UART_TX;

//////////// SRAM //////////
output		    [17:0]		SRAM_A;
output		          		SRAM_CE_n;
inout 		    [15:0]		SRAM_D;
output		          		SRAM_LB_n;
output		          		SRAM_OE_n;
output		          		SRAM_UB_n;
output		          		SRAM_WE_n;

//////////// LPDDR2 //////////
output		     [9:0]		DDR2LP_CA;
output		          		DDR2LP_CK_n;
output		          		DDR2LP_CK_p;
output		     [1:0]		DDR2LP_CKE;
output		     [1:0]		DDR2LP_CS_n;
output		     [3:0]		DDR2LP_DM;
inout 		    [31:0]		DDR2LP_DQ;
inout 		     [3:0]		DDR2LP_DQS_n;
inout 		     [3:0]		DDR2LP_DQS_p;
input 		          		DDR2LP_OCT_RZQ;

//////////// GPIO, GPIO connect to GPIO Default //////////
inout 		    [35:0]		GPIO;

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire			reset_n;

wire [23:0]	disp_data;
wire			disp_clk;
wire			disp_hs;
wire			disp_vs;
wire			disp_de;

wire lpddr2local_init_done;
wire lpddr2_local_cal_success;
wire lpddr2_local_cal_fail;	

//=======================================================
//  Structural coding
//=======================================================
assign reset_n = 1'b1;

    HDMI_QSYS u0 (
        .clk_clk                            			(CLOCK_50_B7A),//clk.clk
        .reset_reset_n                      			(reset_n),		//reset.reset_n
        .led_external_connection_export     			(LEDG),    		//led_external_connection.export
        .i2c_sda_external_connection_export 			(I2C_SDA),		// i2c_sda_external_connection.export
        .i2c_scl_external_connection_export 			(I2C_SCL),		// i2c_scl_external_connection.export
        .key_external_connection_export              (KEY),              //           key_external_connection.export
        .sw_external_connection_export               (SW),                //            sw_external_connection.export
		  
		  
        .alt_vip_itc_0_clocked_video_vid_clk       (disp_clk),		//alt_vip_itc_0_clocked_video.vid_clk
        .alt_vip_itc_0_clocked_video_vid_data      (disp_data),	//.vid_data
        .alt_vip_itc_0_clocked_video_underflow     (),				//.underflow
        .alt_vip_itc_0_clocked_video_vid_datavalid (disp_de),		//.vid_datavalid
        .alt_vip_itc_0_clocked_video_vid_v_sync    (disp_vs),		//.vid_v_sync
        .alt_vip_itc_0_clocked_video_vid_h_sync    (disp_hs),		//.vid_h_sync
        .alt_vip_itc_0_clocked_video_vid_f         (),				//.vid_f
        .alt_vip_itc_0_clocked_video_vid_h         (),				//.vid_h
        .alt_vip_itc_0_clocked_video_vid_v         (),				//.vid_v
        .disp_clk_clk                              (disp_clk),		//disp_clk.clk
		  
        .hdmi_tx_int_n_external_connection_export  (~HDMI_TX_INT),   // hdmi_tx_int_n_external_connection.export
		  
		  
  
		  // LPDDR2
        .memory_mem_ca                               (DDR2LP_CA),                               //                            memory.mem_ca
        .memory_mem_ck                               (DDR2LP_CK_p),                               //                                  .mem_ck
        .memory_mem_ck_n                             (DDR2LP_CK_n),                             //                                  .mem_ck_n
        .memory_mem_cke                              (DDR2LP_CKE),                              //                                  .mem_cke
        .memory_mem_cs_n                             (DDR2LP_CS_n),                             //                                  .mem_cs_n
        .memory_mem_dm                               (DDR2LP_DM),                               //                                  .mem_dm
        .memory_mem_dq                               (DDR2LP_DQ),                               //                                  .mem_dq
        .memory_mem_dqs                              (DDR2LP_DQS_p),                              //                                  .mem_dqs
        .memory_mem_dqs_n                            (DDR2LP_DQS_n),                            //                                  .mem_dqs_n
        .oct_rzqin                                   (DDR2LP_OCT_RZQ),                                   //                               oct.rzqin
        .mem_if_lpddr2_emif_pll_ref_clk_clk          (CLOCK_125_p),          //    mem_if_lpddr2_emif_pll_ref_clk.clk
        .mem_if_lpddr2_emif_status_local_init_done   (lpddr2local_init_done),   //         mem_if_lpddr2_emif_status.local_init_done
        .mem_if_lpddr2_emif_status_local_cal_success (lpddr2_local_cal_success), //                                  .local_cal_success
        .mem_if_lpddr2_emif_status_local_cal_fail    (lpddr2_local_cal_fail),    //                                  .local_cal_fail
        .memory_status_external_connection_export    ({lpddr2_local_cal_success, lpddr2_local_cal_fail, lpddr2local_init_done}),     // memory_status_external_connection.export
		  
			// ADC
        .adc_conduit_end_CONVST                      (ADC_CONVST),                      //                   adc_conduit_end.CONVST
        .adc_conduit_end_SCK                         (ADC_SCK),                         //                                  .SCK
        .adc_conduit_end_SDI                         (ADC_SDI),                         //                                  .SDI
        .adc_conduit_end_SDO                         (ADC_SDO)                          //                                  .SDO
			
			
			
    );

assign HDMI_TX_CLK	= disp_clk;
assign HDMI_TX_D		= disp_data;
assign HDMI_TX_DE		= disp_de;
assign HDMI_TX_HS		= disp_hs;
assign HDMI_TX_VS		= disp_vs;

//assign LEDR = SW;
//assign LEDR[0] = lpddr2local_init_done;
//assign LEDR[1] = lpddr2_local_cal_fail;
//assign LEDR[2] = lpddr2_local_cal_success;




///////////////////////////////
// GPIO
reg [23:0] cnt;
always @ (posedge CLOCK_50_B8A)
begin
	cnt <= cnt + 1;
end

assign GPIO[26] = cnt[12];
assign GPIO[28] = cnt[13];
assign GPIO[30] = cnt[14];
assign GPIO[32] = cnt[15];
assign GPIO[34] = cnt[16];

assign LEDR[9] = cnt[23] & lpddr2local_init_done & lpddr2_local_cal_success;


endmodule
